\ loader.fs

0 [if]
Copyright (C) 2004 by Charles Shattuck.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL information:   http://www.gnu.org/copyleft/lesser.txt
For application information:   http://www.amresearch.com

[then]

only forth also definitions
1 constant tethered  \ Not tethered means with heads.
: nowarn warnings off ; : warn warnings on ; : not 0= ;
nowarn

include ansi.fs  \ Part of Gforth.
warn
: color  ( n - ) create , does> @ >fg attr! ;
red color >red
black color >black
blue color >blue
green color >green

\ Choose, Linux or Windows.
\ include serial-linux.fs
\ include serial-windows.fs
\ open-comm

include compiler.fs
include saver.fs
include dis5x.fs

\ Pick downloader for your microcontroller.
\ include downADuC.fs
include download-cygnal.fs

\ Forth primitives.
include misc8051.fs
tethered [if]  \ Choose interpreter.
	include tether.fs
[else]	include standalone.fs
[then]

\ This is the application.
include debug.fs

\ Patch the reset vector.
start interrupt
: cold stacks 1 .SCON set quit ;
] here $200 org cold ; org [
tethered [if]
	:m # number emit-s m;
	:m ## [ dup 8 rshift $ff and swap $ff and ] # # m;
[else]	headers ] here [ dict org heads ##p! org ]
[then]
report
save
[ .( Host stack= ) .s cr
